
          %-------------------------------------%
\chapter{~~Frontal mesh generation; knitting}\label{\numb section 3}
          %-------------------------------------%

Section \ref{\numb section 2} shows how to build meshes by joining together several regular meshes
(triangles or quadrangles), like patches.
The present section explains how to build a mesh by gradually adding cells, one by one.
We call this approach ``frontal mesh generation'' because, for building a 2D mesh,
we gradually propagate a front of segments; for building a 3D mesh we gradually advance
a front of triangles.
In some cases, the process starts with a given interface and adds cells, one by one,
moving and deforming the interface, until it shrinks and disappears.
In other cases (like in paragraphs \ref{\numb section 3.\numb parag 2},
\ref{\numb section 3.\numb parag 4}, \ref{\numb section 3.\numb parag 6},
\ref{\numb section 3.\numb parag 7}) we begin with nothing at all;
{\maniFEM} finds a starting point by itself.

The user requests frontal mesh generation by creating a {\small\tt\verm{Mesh}::Build} {\small\tt(}
{\small\tt\taag::frontal} {\small\tt)} object;
options are specified by subsequent calls to methods of this object,
e.g.\ {\small\tt boundary}, {\small\tt entire\_\,manifold},
{\small\tt desired\hglue 0.3pt \_\hglue 1.3pt length}.

The frontal mesh generation algorithm behaves differently according to the
topological dimension of the current working manifold (the most recently
declared {\small\tt\verm{Manifold}} object).
If the current working manifold is one-dimensional (which could be $ \mathbb R $ or a curve
in $ \mathbb R^2 $ or in $ \mathbb R^3 $), the frontal mesh generation algorithm builds segments,
as shown in paragraphs \ref{\numb section 3.\numb parag 2}\,--\,\ref{\numb section 3.\numb parag 5},
\ref{\numb section 3.\numb parag 9},
\ref{\numb section 3.\numb parag 17}\,--\,\ref{\numb section 3.\numb parag 20}.
If the current working manifold is two-dimensional (which could be $ \mathbb R^2 $ or
a surface in $ \mathbb R^3 $), the frontal mesh generation algorithm builds triangles,
as shown in paragraphs \ref{\numb section 3.\numb parag 1}\,--\,\ref{\numb section 3.\numb parag 3},
\ref{\numb section 3.\numb parag 6}\,--\,\ref{\numb section 3.\numb parag 9},
\ref{\numb section 3.\numb parag 16}\,--\,\ref{\numb section 3.\numb parag 20},
\ref{\numb section 3.\numb parag 23}\,--\,\ref{\numb section 3.\numb parag 30}.
If the current working manifold is $ \mathbb R^3 $,
the frontal mesh generation algorithm builds tetrahedra,
as shown in paragraphs \ref{\numb section 3.\numb parag 8}, \ref{\numb section 3.\numb parag 25}.
Frontal mesh generation with tetrahedra is presently not fully stable;
however, it works well in most cases.

The algorithm follows the shape of the current working manifold;
when necessary, it {\small\tt project}s each newly constructed vertex on that manifold.
Recall that in this manual we use the term ``manifold'' to mean a manifold without boundary.

Paragraphs \ref{\numb section 3.\numb parag 23}\,--\,\ref{\numb section 3.\numb parag 26}
show examples of non-uniform meshes;
paragraphs \ref{\numb section 3.\numb parag 27}\,--\,\ref{\numb section 3.\numb parag 30}
show examples of anisotropic meshes.

Frontal mesh generation works also on quotient manifolds, as shown in paragraphs
\ref{\numb section 7.\numb parag 23}\,--\,\ref{\numb section 7.\numb parag 26}.

          %--------------%
\section{~~Filling a disk}\label{\numb section 3.\numb parag 1}
          %--------------%

Paragraph \ref{\numb section 2.\numb parag 11} shows how to build a mesh over a disk,
but the quality of the mesh is quite poor.
This is so because the {\small\tt\verm{Mesh}:::Build}\,er with {\small\tt .shape} {\small\tt(} 
{\small\tt\taag::quadrangle} {\small\tt)} treats the disk as a (much) deformed rectangle.

We can ask {\maniFEM} to mesh the disk, starting from its boundary (a circle)
and adding triangles, one by one, until the disk is completely covered\,:
\vskip 10pt

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 3.\numb parag 1}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                             ]
   \verm{Manifold} \azul{RR2} ( \taag::Euclid, \taag::of_dim, \laranja{2} );
   \verm{Function} \azul{xy} = RR2 .build_coordinate_system ( \taag::Lagrange, \taag::of_degree, \laranja{1} );
   \verm{Function} \azul{x} = xy[\laranja{0}], \azul{y} = xy[\laranja{1}];
   
   \verm{Manifold} \azul{circle_manif} = RR2 .implicit ( x*x + y*y == \laranja{1.} );
   \verm{Cell} \azul{N} ( \taag::vertex );  x(N) =  \laranja{0.};   y(N) =  \laranja{1.};
   \verm{Cell} \azul{W} ( \taag::vertex );  x(W) = \laranja{-1.};   y(W) =  \laranja{0.};
   \verm{Cell} \azul{S} ( \taag::vertex );  x(S) =  \laranja{0.};   y(S) = \laranja{-1.};
   \verm{Cell} \azul{E} ( \taag::vertex );  x(E) =  \laranja{1.};   y(E) =  \laranja{0.};

   \verm{Mesh} \azul{NW} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( N ) .stop_at ( W ) .divided_in ( \laranja{10} );
   \verm{Mesh} \azul{WS} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( W ) .stop_at ( S ) .divided_in ( \laranja{10} );
   \verm{Mesh} \azul{SE} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( S ) .stop_at ( E ) .divided_in ( \laranja{10} );
   \verm{Mesh} \azul{EN} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( E ) .stop_at ( N ) .divided_in ( \laranja{10} );
   \verm{Mesh} \azul{circle} = \verm{Mesh}::Build ( \taag::join ) .meshes ( \{ NW, WS, SE, EN \} );
   
   RR2 .set_as_working_manifold();
   \verm{Mesh} \azul{disk} = \verm{Mesh}::Build ( \taag::frontal ) .boundary ( circle )
                                            .desired_length ( \laranja{0.157} );
\end{Verbatim}

\begin{figure}[ht] \centering
 \includegraphics[width=77mm]{disk-with-tri}
 \caption{circle built from patches, interior of disk meshed with frontal method}
 \label{\numb section 3.\numb fig 1}
\end{figure}

We provide the desired length of the segments of the future mesh by invoking the method
{\small\tt desired\hglue 0.3pt \_\hglue 1.3pt length} of the {\small\tt\verm{Mesh}::Build}\,er.
Of course the length of the segments inside the mesh will vary slightly.
We must take care to give as boundary a curve with segments of length approximatively equal
to the desired length (paragraph \ref{\numb section 3.\numb parag 15} discusses
this requirement).

Paragraph \ref{\numb section 12.\numb parag 2} explains the coloring conventions observed
in this manual for {\tt C++} code.
Paragraph \ref{\numb section 12.\numb parag 3} gives details about {\small\tt\taag}\hglue0.5pt s.


          %----------------%
\section{~~Meshing a circle}\label{\numb section 3.\numb parag 2}
          %----------------%

Instead of building the circle by joining four (curved) segments, we can mesh directly
the circle manifold, then mesh the disk\,:

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 3.\numb parag 2}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                             ]
   \verm{Manifold} \azul{RR2} ( \taag::Euclid, \taag::of_dim, \laranja{2} );
   \verm{Function} \azul{xy} = RR2 .build_coordinate_system ( \taag::Lagrange, \taag::of_degree, \laranja{1} );
   \verm{Function} \azul{x} = xy[\laranja{0}], \azul{y} = xy[\laranja{1}];
   \verm{Manifold} \azul{circle_manif} = RR2 .implicit ( x*x + y*y == \laranja{1.} );

   \verm{Mesh} \azul{circle} = \verm{Mesh}::Build ( \taag::frontal ) .entire_manifold()
                                              .desired_length ( \laranja{0.2} );
   
   RR2 .set_as_working_manifold();
   \verm{Mesh} \azul{disk} = \verm{Mesh}::Build ( \taag::frontal ) .boundary ( circle )
                                            .desired_length ( \laranja{0.2} );
\end{Verbatim}
%   disk .export_to_file ( \taag::eps, \verde{"disk.eps"} );

The code above is quite comfortable for the user; he or she only needs to define
the manifold(s) to be meshed and provide the desired (average) length of segments
in the future mesh.
However, this comfort comes at the price of a significant computational effort.
For building the {\small\tt circle}, {\ManiFEM} must first find a starting point for the process
of frontal mesh generation.
In extreme cases, the algorithm may fail to find a starting point on the given manifold.

The user may choose to be more specific in order to save computation time,
by providing a starting point\,:

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,
   baselinestretch=0.94,framesep=2mm                     ]
   \verm{Cell} \azul{A} ( \taag::vertex );  x(A) = \laranja{1.};  y(A) = \laranja{0.};
   \verm{Mesh} \azul{circle} = \verm{Mesh}::Build ( \taag::frontal ) .entire_manifold()
                                              .start_at ( A )
                                              .desired_length ( \laranja{0.2} );
\end{Verbatim}

Also, {\maniFEM} must infer the right orientation of the {\small\tt circle}
as explained in paragraphs \ref{\numb section 3.\numb parag 10} and
\ref{\numb section 3.\numb parag 12}.
Choosing the other orientation would result in an endless process of meshing the exterior of
the disk.
The process of choosing the right orientation implies some computational effort.
The user can make things easier for {\maniFEM} either by attaching an orientation
to the manifold {\small\tt circle\_\,manif} (this feature is not implemented yet) or
by providing the initial direction as shown in paragraph \ref{\numb section 3.\numb parag 11}.

It should be noted that some manifolds may be disconnected; paragragraphs
\ref{\numb section 3.\numb parag 19} and \ref{\numb section 3.\numb parag 24}
show such examples.
In such a situation, invoking method {\small\tt entire\_\,manifold} of a
{\small\tt\verm{Mesh}::Build}\,er will not produce a mesh on the entire manifold
but on one connected component of it.
Perhaps a better name for this method would be
{\small\tt entire\_\hglue 0.4pt connected\_\hglue 0.4pt component\_\,of\_\,manifold} \dots


          %----------------%
\section{~~Inner boundaries}\label{\numb section 3.\numb parag 3}
          %----------------%

Inner boundaries must have the reverse orientation\,:
\vskip 20pt

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 3.\numb parag 3}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                             ]
   \verm{Manifold} \azul{circle} = RR2 .implicit ( x*x + y*y == \laranja{1.} );
   \verm{Mesh} \azul{outer} = \verm{Mesh}::Build ( \taag::frontal )
      .entire_manifold() .desired_length ( \laranja{0.1} );
   \verm{Manifold} \azul{ellipse} = RR2 .implicit ( x*x + (y-\laranja{0.37})*(y-\laranja{0.37}) + \laranja{0.3}*x*y == \laranja{0.25} );
   \verm{Mesh} \azul{inner} = \verm{Mesh}::Build ( \taag::frontal )
      .entire_manifold() .desired_length ( \laranja{0.1} );
   \verm{Mesh} \azul{bdry} = \verm{Mesh}::Build ( \taag::join ) .mesh ( outer ) .mesh ( inner .reverse() );

   RR2 .set_as_working_manifold();
   \verm{Mesh} \azul{disk} = \verm{Mesh}::Build ( \taag::frontal )
      .boundary ( bdry ) .desired_length ( \laranja{0.1} );
\end{Verbatim}
\vfil\eject

\begin{figure}[ht] \centering
 \includegraphics[width=90mm]{disk-with-hole}
  \caption{disk with a hole}
  \label{\numb section 3.\numb fig 2}
\end{figure}

Figure \ref{\numb section 3.\numb fig 2} shows the resulting mesh.

Paragraphs \ref{\numb section 1.\numb parag 2} and \ref{\numb section 1.\numb parag 4} explain
the relation between the orientation of a mesh and the orientation of its boundary.

Paragraphs \ref{\numb section 3.\numb parag 10} and \ref{\numb section 3.\numb parag 12}
explain how {\maniFEM} chooses the orientation of closed curves.


          %--------------------------------%
\section{~~Meshing a three-dimensional loop}\label{\numb section 3.\numb parag 4}
          %--------------------------------%

We may apply the same {\small\tt frontal} algorithm for meshing the circle in
$ \mathbb{R}^3 $ introduced in paragraph \ref{\numb section 2.\numb parag 17}\,:

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 3.\numb parag 4}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                             ]
   \verm{Manifold} \azul{RR3} ( \taag::Euclid, \taag::of_dim, \laranja{3} );
   \verm{Function} \azul{xyz} = RR3 .build_coordinate_system ( \taag::Lagrange, \taag::of_degree, \laranja{1} );
   \verm{Function} \azul{x} = xyz[\laranja{0}], \azul{y} = xyz[\laranja{1}], \azul{z} = xyz[\laranja{2}];

   \verm{Manifold} \azul{circle_manif} = RR3 .implicit ( x*x + y*y == \laranja{1.}, x*y == \laranja{4.}*z );
   
   \verm{Mesh} \azul{circle} = \verm{Mesh}::Build ( \taag::frontal )
      .entire_manifold() .orientation ( \taag::random ) .desired_length ( \laranja{0.1} );
\end{Verbatim}

Unlike for the {\small\tt circle} in paragraph \ref{\numb section 3.\numb parag 2},
there is no way to choose between the two possible orientations of this {\small\tt circle}.
No one is more ``correct'' than the other.
This is why {\maniFEM} requires a call to {\small\tt orientation} {\small\tt(} {\small\tt\taag::random}
{\small\tt)}.
In other cases (e.g.\ for closed curves in $ \mathbb{R}^2 $) calling the {\small\tt orientation}
method is not mandatory; however, even then the user may choose to perform such a call,
thus sparing the computer from the burden of finding the right orientation.
Paragraphs \ref{\numb section 3.\numb parag 10} and \ref{\numb section 3.\numb parag 12}
give more details.

The term ``random'' should not be interpreted in the probabilistic sense.
The orientation of such a mesh is not a random variable, not even a pseudo-random one.
Is it just difficult to predict.

On the other hand, if the orientation matters for you, you can either attach an orientation
to the manifold {\small\tt circle\_\,manif} (this feature is not implemented yet)
or provide a starting point and an initial direction as shown in paragraph
\ref{\numb section 3.\numb parag 11}.
\vfil\eject


          %----------------------------%
\section{~~Starting and stopping points}\label{\numb section 3.\numb parag 5}
          %----------------------------%

In paragraphs \ref{\numb section 3.\numb parag 2} and \ref{\numb section 3.\numb parag 4}
we have meshed the entire closed curve {\small\tt circle}.
If we only want a piece of a curve, we must specify two points, one for starting and
the other one for stopping.

Looking at the example in paragraph \ref{\numb section 2.\numb parag 20}, let us define a
spiral with a slightly different look and switch to frontal mesh generation.

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 3.\numb parag 5}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                             ]
   \verm{Manifold} \azul{RR2} ( \taag::Euclid, \taag::of_dim, \laranja{2} );
   \verm{Function} \azul{xy} = RR2 .build_coordinate_system ( \taag::Lagrange, \taag::of_degree, \laranja{1} );
   \verm{Function} \azul{x} = xy[\laranja{0}], \azul{y} = xy[\laranja{1}];
   \verm{Function} \azul{r} = \verm{power} ( x*x + y*y, \laranja{0.25} );
   const double \azul{pi} = \laranja{3.14159};
   
   RR2 .implicit ( x*\verm{sin}(r) == y*\verm{cos}(r) );
   \cinza{// we don't need to give a name to the implicit manifold}
   \cinza{// the Manifold constructor sets the manifold it builds as working manifold}
   \cinza{// after that, many methods use this working manifold by default}
   \verm{Cell} \azul{A} ( \taag::vertex );  x(A) =     pi*pi;   y(A) = \laranja{0.};
   \verm{Cell} \azul{B} ( \taag::vertex );  x(B) = \laranja{81.}*pi*pi;   y(B) = \laranja{0.};
   \verm{Mesh} \azul{spiral} = \verm{Mesh}::Build ( \taag::frontal )
      .start_at ( A ) .stop_at ( B ) .shortest_path() .desired_length ( \laranja{1.} );
\end{Verbatim}

\begin{figure} [ht] \centering
  \psfrag{A}{\tt\textcolor{textindraw}{A}}
  \psfrag{B}{\tt\textcolor{textindraw}{B}}
  \includegraphics[width=90mm]{spiral-prog}
  \caption{spiral, meshed by frontal method}
 \label{\numb section 3.\numb fig 3}
\end{figure}

Figure \ref{\numb section 3.\numb fig 3} shows the resulting mesh.
In {\small\tt gmsh}, you must select {\small\tt Tools} $\to$ {\small\tt Options} $\to$
{\small\tt Mesh} $\to$ {\small\tt 1D} {\small\tt  elements} in order to see this mesh.

Unlike in paragraph \ref{\numb section 2.\numb parag 20}, we define the spiral through
an implicit equation.
Had we chosen the (natural) definition {\small\tt\azul r = \verm{power} ( x*x + y*y, \laranja{0.5} )},
the very same spiral as in paragraph \ref{\numb section 2.\numb parag 20} would have been
obtained.
For aesthetic reasons, we have chosen a different definition of {\small\tt\azul r}, thus obtaining
a different spacing between the arcs of the spiral.

Another noteworthy difference from paragraph \ref{\numb section 2.\numb parag 20} is that
vertices are distributed uniformly along the spiral (with respect to the distance
in the surrounding space $ \mathbb{R}^2 $).
The segments are too small to be seen in the figure.

Note that there are two ways to go along the spiral starting from {\small\tt A}.
One of them will eventually stumble upon the stopping point {\small\tt B} while
the other one will never meet {\small\tt B}.
{\ManiFEM} has no means to guess which way it should start building the mesh;
by invoking {\small\tt shortest\_\,path}, the user instructs it
to perform a preliminary search in both directions.
The one that first meets {\small\tt B} wins and the mesh is subsequently built along
the winning direction.

Thus, if we want to mesh an arc of a circle, we can use a sequence of statements like

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,
   baselinestretch=0.94,framesep=2mm                     ]

   RR2 .implicit ( (x-x0)*(x-x0) + (y-y0)*(y-y0) == radius * radius );
   \verm{Cell} \azul{A} ( \taag::vertex );  \cinza{// set x(A) and y(A)}
   \verm{Cell} \azul{B} ( \taag::vertex );  \cinza{// set x(B) and y(B)}
   \verm{Mesh} \azul{arc_of_circle} = \verm{Mesh}::Build ( \taag::frontal )
      .start_at ( A ) .stop_at ( B ) .shortest_path() .desired_length ( \mbox{\fontfamily{helvetica}\selectfont{}some\_\,value} );
\end{Verbatim}

However, if we choose {\small\tt A} and {\small\tt B} diametrally opposed, {\maniFEM} will
mesh unpredictably one half of the circle or the other.

Paragraph \ref{\numb section 3.\numb parag 11} shows how we can specify the direction we
want to follow (starting from a given point), thus avoiding ambiguities and also saving
computational time.

Of course we must be careful to choose starting and stopping points belonging to the manifold
(or to {\small\tt project} them explicitly) otherwise the meshing algorithm will either fail to start
or will spin for ever on the circle or spiral, hopelessly searching for {\small\tt B}.


          %-------------------------%
\section{~~Meshing a compact surface}\label{\numb section 3.\numb parag 6}
          %-------------------------%

Recall that in this manual we use the term ``manifold'' to mean a manifold without boundary.
So, the term ``compact surface'' should be understood as ``compact surface without boundary''
like the sphere or the torus.

Just like for the {\small\tt circle} in paragraphs \ref{\numb section 3.\numb parag 2} and
\ref{\numb section 3.\numb parag 4}, if we want to mesh a compact surface entirely
the mesh will have no boundary so we only need to provide the desired (average) length
of segments.
Code below builds a mesh on the sphere.

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 3.\numb parag 6}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                             ]
   \verm{Manifold} \azul{RR3} ( \taag::Euclid, \taag::of_dim, \laranja{3} );
   \verm{Function} \azul{xyz} = RR3 .build_coordinate_system ( \taag::Lagrange, \taag::of_degree, \laranja{1} );
   \verm{Function} \azul{x} = xyz[\laranja{0}], \azul{y} = xyz[\laranja{1}], \azul{z} = xyz[\laranja{2}];
   \verm{Manifold} \azul{sphere_manif} = RR3.implicit ( x*x + y*y + z*z == \laranja{1.} );
   \verm{Mesh} \azul{sphere} = \verm{Mesh}::Build ( \taag::frontal )
      .entire_manifold() .desired_length ( \laranja{0.11} );
\end{Verbatim}

Again, a significant computational effort is made for finding a starting point
for the meshing process.
We can alleviate this burden simply by providing a starting point on the sphere\,:

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,
   baselinestretch=0.94,framesep=2mm                     ]
   \verm{Cell} \azul{A} ( \taag::vertex );  x(A) = \laranja{1.};  y(A) = \laranja{0.};  z(A) = \laranja{0.};
   \verm{Mesh} \azul{sphere} = \verm{Mesh}::Build ( \taag::frontal )
      .entire_manifold() .start_at ( A ) .desired_length ( \laranja{0.11} );
\end{Verbatim}

Also, some computational effort is made for choosing the right orientation of the sphere;
paragraphs \ref{\numb section 3.\numb parag 10} and \ref{\numb section 3.\numb parag 12}
give more details.


          %--------------------------%
\section{~~A more complicated surface}\label{\numb section 3.\numb parag 7}
          %--------------------------%

Here is an example of a compact surface given by a more complicated implicit equation.
It can be vaguely described as a convolution between two tori.

Function {\small\tt\azul{d1}}, defined in the code below, represents the square of the distance
to a circle.
The implicit equation {\small\tt d1} {\small\tt ==} {\small\tt\laranja{0.15}} defines a torus
(it shows up in paragraphs \ref{\numb section 3.\numb parag 24} and
\ref{\numb section 5.\numb parag 5}).
Function {\small\tt\azul{d2}} represents the squared distance to another circle,
orthogonal to the former.

\begin{figure}[ht] \centering
 \includegraphics[width=80mm]{two-tori}
  \caption{convolution between two tori}
  \label{\numb section 3.\numb fig 4}
\end{figure}

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 3.\numb parag 7}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                             ]
   \verm{Manifold} \azul{RR3} ( \taag::Euclid, \taag::of_dim, \laranja{3} );
   \verm{Function} \azul{xyz} = RR3 .build_coordinate_system ( \taag::Lagrange, \taag::of_degree, \laranja{1} );
   \verm{Function} \azul{x} = xyz[\laranja{0}], \azul{y} = xyz[\laranja{1}], \azul{z} = xyz[\laranja{2}];

   \verm{Function} \azul{f1} = \verm{max} ( x*x + y*y, \laranja{0.1} );  \cinza{// we cut by 0.1 to avoid singularities}
   \verm{Function} \azul{f2} = \laranja{1.} - \verm{power} ( f1, \laranja{-0.5} );
   \verm{Function} \azul{d1} = z*z + f1 * f2 * f2;  \cinza{// squared distance to a circle in the xy plane}
   \verm{Function} \azul{f3} = \verm{max} ( (x-\laranja{0.4})*(x-\laranja{0.4}) + z*z, \laranja{0.1} );
   \verm{Function} \azul{f4} = \laranja{1.} - \verm{power} ( f3, \laranja{-0.5} );
   \verm{Function} \azul{d2} = y*y + f3 * f4 * f4;  \cinza{// squared distance to a circle in the xz plane}

   \verm{Manifold} \azul{tori_manif} = RR3 .implicit
      ( \verm{smooth_min} ( d1, d2, \taag::threshold, \laranja{0.2} ) == \laranja{0.15} );

   \verm{Mesh} \azul{two_tori} = \verm{Mesh}::Build ( \taag::frontal )
      .entire_manifold() .desired_length ( \laranja{0.09} );
\end{Verbatim}

Function {\small\tt\verm{smooth\_\,min}} gives a smooth approximation of the minimum between
two or more {\small\tt\verm{Function}} objects.
It is equal to the true minimum if the difference between the two values is higher, in
absolute value, than the provided threshold.
When the difference is smaller than the threshold, it gives a $ C^1 $ interpolation between
the two values.

Comments at the end of paragraph \ref{\numb section 3.\numb parag 6} apply here, too$\;$:
{\maniFEM} must find a starting point and the right orientation.

If we want sharp edges, we must build the edges first as explained in paragraphs
\ref{\numb section 3.\numb parag 18}, \ref{\numb section 3.\numb parag 19} and
\ref{\numb section 3.\numb parag 24}.


          %--------------------------------%
\section{~~Filling a volume with tetrahedra}\label{\numb section 3.\numb parag 8}
          %--------------------------------%

If the current working manifold has dimension three, the frontal mesh generation algorithm
builds tetrahedra.

In order to fill, for instance, the sphere bulit in paragraph \ref{\numb section 3.\numb parag 6}
with tetrahedra, it suffices to add two statements\,:
\vskip 15pt

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 3.\numb parag 8}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                             ]
   RR3 .set_as_working_manifold();
   \verm{Mesh} \azul{ball} = \verm{Mesh}::Build ( \taag::frontal ) .boundary ( sphere )
                                            .desired_length ( \laranja{0.11} );
\end{Verbatim}

In figure \ref{\numb section 3.\numb fig 5} below we only show a slice of the {\small\tt ball},
in order to see the interior.

\begin{figure}[ht] \centering
 \includegraphics[width=80mm]{slice-of-ball}
 \caption{slice of a ball made of tetrahedra}
 \label{\numb section 3.\numb fig 5}
\end{figure}

The same statements above can be used to fill any volume defined by a compact surface with no boundary,
like {\small\tt two\_tori} in paragraph \ref{\numb section 3.\numb parag 7} or
\ref{\numb section 3.\numb parag 24} (as shown in paragraph \ref{\numb section 3.\numb parag 25}),
or {\small\tt perf\_sphere} in paragraph \ref{\numb section 3.\numb parag 19}.
In paragraph \ref{\numb section 3.\numb parag 18},
we must close the mesh {\small\tt sphere\_and\_cylinder} by adding the {\small\tt disk}
before calling frontal mesh generation with tetrahedra.
Note that mesh generation with tetrahedra is not fully stable in \maniFEM{} yet,
although it gets the job done in most examples.
Work is ongoing in order to improve the stability and quality of mesh generation with tetrahedra.

The boundary provided by the user must have an almost constant segment size,
otherwise \maniFEM{} will be unable to build the required tetrahedra.
For instance, one can slighlty modify the code in paragraph \ref{\numb section 2.\numb parag 8}
in order to mesh the entire sphere; however, this will produce a mesh of triangles 
whose side lengths vary too much; thus, the resulting mesh cannot be provided as a starting point
for frontal mesh generation with tetrahedra.
This is similar to the situation described in paragraph \ref{\numb section 3.\numb parag 1};
see also paragraph \ref{\numb section 3.\numb parag 15}.


          %------------------%
\section{~~A bumpy hemisphere}\label{\numb section 3.\numb parag 9}
          %------------------%

We now look again at the surface in paragraph \ref{\numb section 2.\numb parag 19}
and build it with frontal meshing, using fewer lines of code.

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 3.\numb parag 9}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                             ]
   \verm{Manifold} \azul{nut} = RR3 .implicit ( x*x + y*y + z*z + \laranja{1.5}*x*y*z == \laranja{1.} );
   \verm{Manifold} \azul{base} = nut .implicit ( x*x + \laranja{3.}*z == \laranja{0.} );
   \verm{Mesh} \azul{circle} = \verm{Mesh}::Build ( \taag::frontal ) .entire_manifold()  \cinza{// 'base' is used}
      .desired_length ( \laranja{0.1} ) .orientation ( \taag::random );  \cinza{//  as working manifold}
   
   nut .set_as_working_manifold();
   \verm{Mesh} \azul{bumpy} = \verm{Mesh}::Build ( \taag::frontal )  \cinza{// 'nut' is used as working manifold}
      .boundary ( circle ) .desired_length ( \laranja{0.1} ) .orientation ( \taag::random );
\end{Verbatim}

In this example, the issue of the orientation can be really tricky.
An orientation of the {\small\tt circle} is chosen at random.
Also, {\maniFEM} will make a random choice of starting to grow the mesh on one or the other side
of {\small\tt circle}, so we will get unpredictably the upper or the lower hemisphere.
Paragraphs \ref{\numb section 3.\numb parag 10}, \ref{\numb section 3.\numb parag 12} and
\ref{\numb section 3.\numb parag 13} give more details.


          %-----------------------------%
\section{~~How the orientation is chosen}\label{\numb section 3.\numb parag 10}
          %-----------------------------%

In \maniFEM, cells and meshes are oriented (paragraphs \ref{\numb section 1.\numb parag 2}
and \ref{\numb section 9.\numb parag 7} provide details).
For building a mesh with frontal method, {\maniFEM} needs to know which orientation we want.

Manifolds may be oriented or not.
Euclidian manifolds (that is, the space $ \mathbb{R}^d $) have an intrinsic orientation,
given by the natural order of the $d$ coordinates.
Parametric manifolds inherit the intrinsic orientation from the space of parameters.
Implicit manifolds, however, have no intrinsic orientation.
We can specify an orientation of a manifold by attaching an outer form to it
(this feature is not implemented yet); otherwise, it will be considered not oriented.

In the example in paragraph \ref{\numb section 3.\numb parag 1}, the boundary {\small\tt circle}
is oriented according to the four segments composing it, {\small\tt NW}, {\small\tt WS},
{\small\tt SE} and {\small\tt EN}.
\ {\ManiFEM} uses the intrinsic orientation of the surrounding space {\small\tt RR2} in order
to determine the desired orientation of the mesh {\small\tt disk}.
The orientation of the boundary {\small\tt circle} is important;
together with the intrinsic orientation of the surrounding space,
it determines on which side of the circle the mesh will start to grow.
Had we built the segments {\small\tt NW}, {\small\tt WS}, {\small\tt SE} and {\small\tt EN} in the
opposite direction (that is, {\small\tt WN}, {\small\tt SW}, {\small\tt ES} and {\small\tt NE})
the program would try to mesh the exterior of the disk, never stopping.

We said before that implicit manifolds have no intrinsic orientation.
Compact manifolds of co-dimension one (closed curves in $ \mathbb{R}^2 $,
compact surfaces in $ \mathbb{R}^3 $) are a special case.\,%
\footnote{{} Recall that in this manual we use the term ``manifold'' to mean a manifold without boundary.}
There is a ``privileged'' orientation of a compact manifold of co-dimension one,
which is compatible with the intrinsic orientation of the surrounding space.
We call this orientation {\small\tt inherent}; paragraph \ref{\numb section 3.\numb parag 12}
discusses this topic.

Open curves (like the {\small\tt spiral} in paragraphs \ref{\numb section 3.\numb parag 5} and
\ref{\numb section 3.\numb parag 11}), as well as non-compact manifolds
(like the {\small\tt cylinder} in paragraphs \ref{\numb section 3.\numb parag 18} and
\ref{\numb section 3.\numb parag 19}), have no privileged orientation.
These manifolds are considered not oriented, unless we attach to them an outer form
(this feature is not implemented yet).
A call to method {\small\tt orientation} {\small\tt(} {\small\tt\taag::random} {\small\tt)}
instructs {\maniFEM} to choose an arbitrary orientation.
For curves, we can call method {\small\tt shortest\_\,path()} and {\maniFEM} will perform
a preliminary search in both directions then choose the one that first meets the stopping point.

Curves in $ \mathbb{R}^3 $, either closed like the {\small\tt circle} in paragraphs
\ref{\numb section 3.\numb parag 4} and \ref{\numb section 3.\numb parag 9} or open,
have no privileged orientation either (because they have co-dimension two).
There is no way to decide which of its two possible orientations
should be chosen; no one is more ``correct'' than the other.
This is why {\maniFEM} will reject a tentative to define {\small\tt\azul{circle}} without
a call to method {\small\tt orientation} {\small\tt(} {\small\tt\taag::random} {\small\tt)}
or to {\small\tt shortest\_\,path()}.
If we specify {\small\tt entire\_manifold} without providing an {\small\tt orientation},
we will get a run-time error if the current working manifold has dimension 1 and
the geometric dimension (that is, the number of coordinates) is 3.

The options given to the constructor of {\small\tt\verm{Mesh}}\hglue0.5pt es {\small\tt\azul{circle}} and
{\small\tt\azul{bumpy}} in paragraph \ref{\numb section 3.\numb parag 9} are discussed in paragraph
\ref{\numb section 3.\numb parag 13}.


          %------------------------%
\section{~~Specifying the direction}\label{\numb section 3.\numb parag 11}
          %------------------------%

For one-dimensional manifolds, we can specify, along with the starting point,
a starting direction, thus saving some computational time.
The code producing the spiral in paragraph \ref{\numb section 3.\numb parag 5}
can be changed as below.

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,
   baselinestretch=0.94,framesep=2mm                     ]
   \verm{Cell} \azul{A} ( \taag::vertex );  x(A) =    pi*pi;  y(A) = \laranja{0.};
   \verm{Cell} \azul{B} ( \taag::vertex );  x(B) = \laranja{81}*pi*pi;  y(B) = \laranja{0.};
   std::vector < double > \azul{direc} = \{ \laranja{0.}, \laranja{1.} \};
   \verm{Mesh} \azul{spiral} = \verm{Mesh}::Build ( \taag::frontal )
      .start_at ( A ) .towards ( direc ) .stop_at ( B ) .desired_length ( \laranja{1.} );
\end{Verbatim}

Note that the vector {\small\tt direc} is associated to the point {\small\tt A}
(is tangent to the manifold at point {\small\tt A}).

Recall that open curves have no ``default'' (or ``inherent'') orientation.
{\ManiFEM} uses the vector {\small\tt direc} as an indication about where to go.

It is the user's responsibility to ensure that, going in the specified direction,
the algorithm will eventually meet the stopping point {\small\tt B}.
Otherwise, the algorithm may spin endlessly along the spiral.

We could specify in a similar fashion the orientation of {\small\tt circle} in paragraph
\ref{\numb section 3.\numb parag 2}, thus saving some computational time\,:

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,
   baselinestretch=0.94,framesep=2mm                     ]
   \verm{Cell} \azul{A} ( \taag::vertex );  x(A) = \laranja{1.};  y(A) = \laranja{0.};
   \verm{Mesh} \azul{circle} = \verm{Mesh}::Build ( \taag::frontal ) .entire_manifold()
      .start_at ( A ) .towards ( \{ \laranja{0.}, \laranja{1.} \} ) .desired_length ( \laranja{0.2} );
\end{Verbatim}

If, in the above, we choose the opposite {\small\tt direc}tion,
{\maniFEM} will later try to mesh the exterior of the disk, never stopping.

The same technique can be used for building the {\small\tt circle} in paragraph
\ref{\numb section 3.\numb parag 4}, thus avoiding \maniFEM's random choice of the orientation\,:

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,
   baselinestretch=0.94,framesep=2mm                     ]
   \verm{Cell} \azul{S} ( \taag::vertex );  x(S) = \laranja{0.};  y(S) = \laranja{-1.};  z(S) = \laranja{0.};
   \verm{Manifold} \azul{circle_manif} = RR3 .implicit ( x*x + y*y == \laranja{1.}, x*y == \laranja{4.}*z );
   \verm{Mesh} \azul{circle} = \verm{Mesh}::Build ( \taag::frontal ) .entire_manifold()
      .start_at ( S ) .towards ( \{ \laranja{1.}, \laranja{0.}, \laranja{0.} \} ) .desired_length ( \laranja{0.2} );
\end{Verbatim}

This also applies to the example in paragraph \ref{\numb section 3.\numb parag 9}.
However, because a surface {\small\tt bumpy} is subsequently built,
the topologic considerations are more complex, so we postpone this
discussion to paragraph \ref{\numb section 3.\numb parag 13}.


          %---------------------------------------%
\section{~~The intrinsic and inherent orientations}\label{\numb section 3.\numb parag 12}
          %---------------------------------------%

Euclidian manifolds have an intrinsic orientation given by the natural order of the
coordinates.
{\ManiFEM} will always use this orientation when the working manifold is Euclidian.
We can enforce the requirement of using the intrinsic orientation by calling method
{\small\tt orientation} {\small\tt(} {\small\tt\taag::intrinsic} {\small\tt)}
of the {\small\tt\verm{Mesh}::Build}\,er.
However, this call is not necessary; {\maniFEM} will consider the intrinsic orientation by default.
This happens for the disk in paragraphs \ref{\numb section 3.\numb parag 1} and
\ref{\numb section 3.\numb parag 2}, for the diamond in
paragraph \ref{\numb section 3.\numb parag 16} and for the annulus in paragraphs
\ref{\numb section 3.\numb parag 3}, \ref{\numb section 3.\numb parag 23}
and \ref{\numb section 3.\numb parag 27}.

Compact manifolds of co-dimension one (closed curves in $ \mathbb{R}^2 $,
compact surfaces in $ \mathbb{R}^3 $) have a privileged orientation,
compatible with the intrinsic orientation of the surrounding space;
we call this orientation ``inherent''.
Such a manifold cuts the surrounding space in two regions, one of them being bounded;
the ``inherent'' orientation is the one pointing towards the unbounded region;
intuitively speaking, it points ``outwards''.
{\ManiFEM} will choose it in some situations, unless we call method
{\small\tt orientation} {\small\tt(} {\small\tt\taag::random} {\small\tt)}
of the {\small\tt\verm{Mesh}::Build}\,er.
We can enforce the requirement of finding the inherent orientation by invoking method
{\small\tt orientation} {\small\tt(} {\small\tt\taag::inherent} {\small\tt)};
however, {\maniFEM} will consider the inherent orientation by default when we provide no stopping
point (for one-dimensional meshes) or we provide no boundary (for two-dimensional meshes).
In these cases, {\maniFEM} will assume that the manifold is compact and, if it has
co-dimension one, the inherent orientation will be used.
This happens for the {\small\tt\azul{circle}} in paragraph \ref{\numb section 3.\numb parag 2},
for the {\small\tt\azul{sphere}} in paragraph \ref{\numb section 3.\numb parag 6} and for the
{\small\tt\azul{tori}} in paragraph \ref{\numb section 3.\numb parag 7}.

If we do provide a stopping point, or a boundary, {\maniFEM} has no means to know in
advance whether the manifold
is compact or not, so it will not try to find the inherent orientation.
This happens for the {\small\tt\azul{spiral}} and for the {\small\tt\azul{arc\_\,of\_\,circle}}
in paragraph \ref{\numb section 3.\numb parag 5}, for the {\small\tt\azul{bumpy}} hemisphere
in paragraph \ref{\numb section 3.\numb parag 9}, for the {\small\tt\azul{piece\_\,of\_\,cyl}} and
{\small\tt\azul{piece\_\,of\_\,sph}} in paragraphs \ref{\numb section 3.\numb parag 18} and
\ref{\numb section 3.\numb parag 19} and others.
In these situations, we may require specifically the inherent orientation by invoking method
{\small\tt orientation} {\small\tt(} {\small\tt\taag::inherent} {\small\tt)}
of the {\small\tt\verm{Mesh}::Build}\,er.
Do not misuse this option; if you ask {\maniFEM} to find the inherent orientation of an open
curve or of a non-compact surface, it will not complain but will hopelessly try to mesh
the entire manifold, never stopping.
For instance, in paragraph \ref{\numb section 3.\numb parag 5} it makes sense to enforce the
inherent orientation for the {\small\tt\azul{arc\_\,of\_\,circle}} but not for the
{\small\tt\azul{spiral}}.
Also, in paragraphs \ref{\numb section 3.\numb parag 18} and
\ref{\numb section 3.\numb parag 19} it makes sense to enforce the inherent orientation
for the {\small\tt\azul{piece\_\,of\_\,sph}} but not for the {\small\tt\azul{piece\_\,of\_\,cyl}}.

Determining the intrinsic orientation of a Euclidian manifold is computationally
very cheap.
However, determining the inherent orientation of a manifold of co-dimension one is not
a trivial computational process.
{\ManiFEM} is unable to determine this orientation by looking at the equations defining
the manifold; it needs a mesh on the entire manifold.

So, in paragraph \ref{\numb section 3.\numb parag 2} we obtain a correctly oriented mesh
on the disk, with no need to provide any specific information about the orientation of
{\small\tt circle\_\,manif}.
Behind the curtains, {\maniFEM} builds a mesh on {\small\tt circle\_\,manif} with
an initially arbitrary orientation, then checks its consistency
within the surrounding manifold and, if necessary, switches the orientation of the produced mesh.
Later, when we ask {\maniFEM} to mesh the {\small\tt\azul{disk}}, the orientation of the boundary
(together with the intrinsic orientation of the surrounding space {\small\tt RR2})
defines whether the interior or the exterior of the disk is to be meshed.

A similar process happens for compact surfaces in $ \mathbb{R}^3 $ like those
considered in paragraphs \ref{\numb section 3.\numb parag 6} and
\ref{\numb section 3.\numb parag 7},
except that checking the orientation of a compact surface has a computational cost
considerably higher than for a closed curve in $ \mathbb{R}^2 $.

We can save some computing time if you specify the orientation,
either by providing more information to the {\small\tt\verm{Mesh}::Build}\,er as shown
in paragraph \ref{\numb section 3.\numb parag 14} or by attaching this information to
the manifold itself by means of an outer form (this feature is not implemented yet).
% in order to alleviate the computational burden
 
If the orientation is not important for you, you can invoke method
{\small\tt orientation}~{\small\tt(}~{\small\tt\taag::random}~{\small\tt)}
of the {\small\tt\verm{Mesh}::Build}\,er and {\maniFEM} will not waste
computing time to find the inherent orientation.


          %-------------------------------%
\section{~~Revisiting the bumpy hemisphere}\label{\numb section 3.\numb parag 13}
          %-------------------------------%

%The random behaviour in this example is quite dramatic.
Let us have a closer look at the code in paragraph \ref{\numb section 3.\numb parag 9}.
The manifold {\small\tt nut} has a unique orientation consistent with the surrounding
space, just like those in paragraphs \ref{\numb section 3.\numb parag 6} and
\ref{\numb section 3.\numb parag 7}, but the {\small\tt base} within it has not.
This is why, when we build the {\small\tt\azul{circle}}, we must call method
{\small\tt orientation} {\small\tt(} {\small\tt\taag::random} {\small\tt)}
of the {\small\tt\verm{Mesh}::Build}\,er,
or specify the orientation by providing a starting point and a starting direction
as explained in paragraph \ref{\numb section 3.\numb parag 11}.

When we build {\small\tt\azul{bumpy}}, since we are providing a boundary, {\maniFEM} does not treat
the current working manifold {\small\tt nut} as compact, that is, it does not try to determine an
inherent orientation.
If method {\small\tt orientation} {\small\tt(} {\small\tt\taag::random} {\small\tt)} is invoked,
{\maniFEM} will start the meshing process on an arbitrary side of {\small\tt circle},
thus meshing unpredictably the upper or the lower {\small\tt bumpy} hemisphere.

If we enforce the orientation by calling method
{\small\tt orientation}\hskip 4pt{\small\tt(}\hskip 4pt{\small\tt\taag::inherent}\hskip 4pt{\small\tt)}
of the\break
{\small\tt\verm{Mesh}::Build}\,er, {\maniFEM} will assume the current working manifold is compact.
In order to find out the inherent orientation of this manifold,
it will mesh (behind the curtains) both halves of the {\small\tt nut};
let's call them {\small\tt\azul{msh1}} and {\small\tt\azul{msh2}}.
Note that the {\small\tt circle} has already been built, so its orientation is given.
Both {\small\tt msh1} and {\small\tt msh2} have {\small\tt circle} as boundary,
which means that they have mutually incompatible orientations; they cannot be {\small\tt join}ed.
But the reverse of any of them can be {\small\tt join}ed with the other one, the result being a
mesh on the entire bumpy sphere.
Two choices are possible\,: either {\small\tt msh1.reverse()} is {\small\tt join}ed with
{\small\tt msh2} or {\small\tt msh1} is {\small\tt join}ed with {\small\tt msh2.reverse()},
resulting in two meshes on the same compact surface with opposite orientations.
One of these orientations is compatible with the intrinsic orientation of the surrounding space
$ \mathbb{R}^3 $ and is called inherent orientation.
If the first one is correctly oriented, {\small\tt msh2} will be returned;
if the second one is correctly oriented, {\small\tt msh1} will be returned.

Thus, in the code below we will obtain the upper hemisphere.

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,
   baselinestretch=0.94,framesep=2mm                     ]
   \verm{Manifold} \azul{nut} = RR3.implicit ( x*x + y*y + z*z + \laranja{1.5}*x*y*z == \laranja{1.} );
   \verm{Manifold} \azul{base} = nut.implicit ( x*x + 3.*z == 0. );

   \verm{Cell} \azul{S} ( \taag::vertex );  x(S) = \laranja{0.};  y(S) = \laranja{-1.};  z(S) = \laranja{0.};
   \verm{Mesh} \azul{circle} = \verm{Mesh}::Build ( \taag::frontal ) .entire_manifold()
      .start_at ( S ) .towards ( \{ \laranja{1.}, \laranja{0.}, \laranja{0.} \} ) .desired_length ( \laranja{0.1} );

   nut .set_as_working_manifold();
   \verm{Mesh} \azul{bumpy} = \verm{Mesh}::Build ( \taag::frontal ) .boundary ( circle )
      .desired_length ( \laranja{0.1} ) .orientation ( \taag::inherent );
\end{Verbatim}

Code below will produce the lower hemisphere.

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,
   baselinestretch=0.94,framesep=2mm                     ]
   \verm{Manifold} \azul{nut} = RR3.implicit ( x*x + y*y + z*z + \laranja{1.5}*x*y*z == \laranja{1.} );
   \verm{Manifold} \azul{base} = nut.implicit ( x*x + 3.*z == 0. );

   \verm{Cell} \azul{S} ( \taag::vertex );  x(S) = \laranja{0.};  y(S) = \laranja{-1.};  z(S) = \laranja{0.};
   \verm{Mesh} \azul{circle} = \verm{Mesh}::Build ( \taag::frontal ) .entire_manifold()
      .start_at ( S ) .towards ( \{ \laranja{-1.}, \laranja{0.}, \laranja{0.} \} ) .desired_length ( \laranja{0.1} );

   nut .set_as_working_manifold();
   \verm{Mesh} \azul{bumpy} = \verm{Mesh}::Build ( \taag::frontal ) .boundary ( circle )
      .desired_length ( \laranja{0.1} ) .orientation ( \taag::inherent );
\end{Verbatim}

Code below will mesh unpredictably either the upper or the lower
hemisphere, but only due to the random choice in the orientation of {\small\tt circle}.
The construction of {\small\tt\azul{bumpy}} is uniquely determined by the orientation of
{\small\tt circle}.

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,
   baselinestretch=0.94,framesep=2mm                     ]
   \verm{Manifold} \azul{nut} = RR3.implicit ( x*x + y*y + z*z + \laranja{1.5}*x*y*z == \laranja{1.} );
   \verm{Manifold} \azul{base} = nut.implicit ( x*x + 3.*z == 0. );

   \verm{Mesh} \azul{circle} = \verm{Mesh}::Build ( \taag::frontal ) .entire_manifold()
      .orientation ( \taag::random ) .desired_length ( \laranja{0.1} );

   nut .set_as_working_manifold();
   \verm{Mesh} \azul{bumpy} = \verm{Mesh}::Build ( \taag::frontal ) .boundary ( circle )
      .desired_length ( \laranja{0.1} ) .orientation ( \taag::inherent );
\end{Verbatim}


          %------------------------%
\section{~~Specifying the direction}\label{\numb section 3.\numb parag 14}
          %------------------------%

In paragraph \ref{\numb section 3.\numb parag 11} we have seen how we can specify the direction
of propagation of the mesh for one-dimensional manifolds.
A similar approach can be taken for two-dimensional meshes.
For instance, code below will mesh the upper half of the ``bumpy hemisphere'' already considered
in paragraphs \ref{\numb section 2.\numb parag 19}, \ref{\numb section 3.\numb parag 9} and
\ref{\numb section 3.\numb parag 13}, oriented upwards.

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 3.\numb parag 14}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                              ]
   \verm{Cell} \azul{S} ( \taag::vertex );  x(S) = \laranja{0.};  y(S) = \laranja{-1.};  z(S) = \laranja{0.};
   std::vector < double > \azul{tau} \{ \laranja{1.}, \laranja{0.}, \laranja{0.} \};
   \verm{Mesh} \azul{circle} = \verm{Mesh}::Build ( \taag::frontal ) .entire_manifold()
      .start_at ( S ) .towards ( tau ) .desired_length ( \laranja{0.1} );
   nut .set_as_working_manifold();
   std::vector < double > \azul{N} \{ \laranja{0.}, \laranja{0.}, \laranja{1.} \};
   \verm{Mesh} \azul{bumpy} = \verm{Mesh}::Build ( \taag::frontal ) .boundary ( circle )
      .start_at ( S ) .towards ( N ) .desired_length ( \laranja{0.1} );
\end{Verbatim}

If we define {\small\tt\azul N} as \catcode`<=1\catcode`>=2\catcode`{=12\catcode`}=12<\small\tt {>
<\small\tt\laranja0\laranja.,> <\small\tt\laranja0\laranja.,>
<\small\tt \laranja-\laranja1\laranja.> <\small\tt }>\catcode`<=12\catcode`>=12\catcode`{=1\catcode`}=2, we will obtain
the lower half of the ``sphere'', still oriented upwards.

If we define {\small\tt\azul{tau}} as \catcode`<=1\catcode`>=2\catcode`{=12\catcode`}=12<\small\tt {>
<\small\tt\laranja-\laranja1\laranja.,> <\small\tt\laranja0\laranja.,> <\small\tt\laranja0\laranja.> <\small\tt }>\catcode`<=12\catcode`>=12\catcode`{=1\catcode`}=2, we will get a mesh
oriented downwards.

We do not need to provide a direction when meshing (with triangles) a region of $ \mathbb R^2 $.
The orientation of the segments on the boundary of the future mesh provides this direction.
Similarly, when we mesh three-dimensional domains with tetrahedra, the orientation
of the triangles on the boundary provided by the user determines the direction
of frontal mesh generation.


          %---------------------%
\section{~~Geometric limitations}\label{\numb section 3.\numb parag 15}
          %---------------------%

Frontal mesh generation has its limits.
{\ManiFEM} cannot mesh a manifold whose curvature is too high when compared to the
length of the segments.
The example in paragraph \ref{\numb section 3.\numb parag 7} is ``on the edge'', that is,
if we increase the segment size the meshing process will probably get stuck somewhere.
On the other hand, decreasing the segment size will make the meshing process easier.

Also, we should avoid domains whose boundary has components too close to each other,
when compared to the segment size.
In this respect, the example in paragraph \ref{\numb section 3.\numb parag 3} is also
``on the edge''.
In contrast, {\maniFEM} is ``at ease'' when meshing the same domain with other options,
like in paragraphs \ref{\numb section 3.\numb parag 23}, or
\ref{\numb section 3.\numb parag 26}\,--\,\ref{\numb section 3.\numb parag 30}.

Sharp edges and singular points must be dealt with as described in subsequent paragraphs.

The example in paragraph \ref{\numb section 3.\numb parag 1} is also ``on the edge''
for a different reason.
While {\maniFEM} tries to build a mesh with segments of constant given length,
the length of the segments on the boundary of the disk varies (paragraphs
\ref{\numb section 2.\numb parag 6} and \ref{\numb section 2.\numb parag 7} explain why).
This contradiction puts the algorithm in a difficult position.
If the variation were larger (or sharper) the algorithm might stop with some error message.
In contrast, {\maniFEM} is ``at ease'' when meshing the disk in paragraph
\ref{\numb section 3.\numb parag 2} because there the segments on the boundary have
(approximately) constant length.

When a {\small\tt\verm{Function}} is provided as desired length
(paragraphs \ref{\numb section 3.\numb parag 23} and \ref{\numb section 3.\numb parag 24}),
it is the user's resposibility to ensure it takes always positive values and
that it is reasonably smooth (has no sharp variations).
The same holds if you define a Riemann metric
(paragraphs \ref{\numb section 3.\numb parag 26}\,--\,\ref{\numb section 3.\numb parag 30}).
You should be careful to provide a definite positive matrix if you use the approach
in paragraph \ref{\numb section 3.\numb parag 27} or \ref{\numb section 3.\numb parag 28}.
You should be careful to provide a positive principal part and a semi-positive deviatoric part
if you use the approach in paragraph \ref{\numb section 3.\numb parag 29} or
\ref{\numb section 3.\numb parag 30}.

Frontal mesh generation with tetrahedra is presently not fully stable.
However, it works well in most cases.


          %------------%
\section{~~Sharp angles}\label{\numb section 3.\numb parag 16}
          %------------%

{\ManiFEM} can deal with non-smooth domains.
The user must define separately smooth pieces of the boundary and then join them.

Here is how to mesh the diamond-shaped domain in paragraph \ref{\numb section 2.\numb parag 13}.

\vskip 20pt
\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 3.\numb parag 16}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                              ]
   \cinza{// we define the arcs NW, WS, SE and EN either as segments, like in}
   RR2 .implicit ( x*y + x - y == \laranja{-1.} );
   \verm{Mesh} \azul{NW} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( N ) .stop_at ( W ) .divided_in ( \laranja{12} );
   \cinza{// or with tag::frontal like in}

   RR2 .implicit ( x*y - x - y ==  \laranja{1.} );
   \verm{Mesh} \azul{WS} = \verm{Mesh}::Build ( \taag::frontal )
      .start_at ( W ) .stop_at ( S ) .desired_length ( \laranja{0.1} );
   \cinza{// ... //}
             
   \verm{Mesh} \azul{bdry} = \verm{Mesh}::Build ( \taag::join ) .meshes ( \{ NW, WS, SE, EN \} );

   RR2 .set_as_working_manifold();
   \verm{Mesh} \azul{diamond} = \verm{Mesh}::Build ( \taag::frontal )
      .boundary ( bdry ) .desired_length ( \laranja{0.1} );
\end{Verbatim}


          %-------------------------%
\section{~~Intersection of manifolds}\label{\numb section 3.\numb parag 17}
          %-------------------------%

For computing the position of corners, we can project on zero-dimensional manifolds
(as already done in paragraph \ref{\numb section 2.\numb parag 14})\,:

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 3.\numb parag 17}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                              ]
   \verm{Manifold} \azul{big_circle_left}  = RR2 .implicit ( (x-\laranja{2.})*(x-\laranja{2.}) + y*y == \laranja{4.} );
   \verm{Manifold} \azul{big_circle_right} = RR2 .implicit ( (x+\laranja{1.})*(x+\laranja{1.}) + y*y == \laranja{4.} );
   \verm{Manifold} \azul{two_points} ( \taag::intersect, big_circle_left, big_circle_right );

   \verm{Cell} \azul{A} ( \taag::vertex, \taag::of_coords, \{ \laranja{0.},  \laranja{1.} \}, \taag::project );
   \verm{Cell} \azul{B} ( \taag::vertex, \taag::of_coords, \{ \laranja{0.}, \laranja{-1.} \}, \taag::project );
\end{Verbatim}

% \begin{figure}[ht] \centering
%   \psfrag{A}{\small\tt\textcolor{textindraw}{A}}
%   \psfrag{B}{\small\tt\textcolor{textindraw}{B}}
%   \includegraphics[width=120mm]{infinity}
%   \caption{an infinity-shaped mesh}
%   \label{\numb section 3.\numb fig 6}
% \end{figure}


          %-----------%
\section{~~Sharp edges}\label{\numb section 3.\numb parag 18}
          %-----------%

We can mesh surfaces with sharp edges, by building individually smooth pieces of surface
and then {\small\tt join}ing them.
The edges must be built first;
thus, some previous knowledge about the geometry of the surface is needed.

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 3.\numb parag 18}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                              ]
   const double \azul{rs} = \laranja{1.};    \cinza{// radius of the sphere}
   const double \azul{rc} = \laranja{0.45};  \cinza{// radius of the cylinder}
   const double \azul{seg_size} = \laranja{0.1};

   \verm{Manifold} \azul{cylinder} = RR3 .implicit ( y*y + (z-\laranja{0.5})*(z-\laranja{0.5}) == rc*rc );
   \verm{Manifold} \azul{sphere} = RR3 .implicit ( x*x + y*y + z*z == rs*rs );
   cylinder .implicit ( x == \laranja{1.5} );  \cinza{// we cut the cylinder on its right side}
   \verm{Cell} \azul{start_1} ( \taag::vertex, \taag::of_coords, \{ \laranja{1.5}, \laranja{0.}, \laranja{0.5} + rc \} );
   \verm{Mesh} \azul{circle_1} = \verm{Mesh}::Build ( \taag::frontal ) .desired_length ( seg_size )
      .start_at ( start_1 ) .towards ( \{ \laranja{0.}, \laranja{1.}, \laranja{0.} \} ) .entire_manifold();

   \cinza{// we cut the cylinder on its left side with a sphere}
   \verm{Manifold} \azul{interface} ( \taag::intersect, cylinder, sphere );
   \verm{Cell} \azul{start_2} ( \taag::vertex, \taag::of_coords, \{ \laranja{1.}, \laranja{0.}, \laranja{0.5} - rc \}, \taag::project );
   \verm{Mesh} \azul{circle_2} = \verm{Mesh}::Build ( \taag::frontal ) .desired_length ( seg_size )
      .start_at ( start_2 ) .towards ( \{ \laranja{0.}, \laranja{-1.}, \laranja{0.} \} ) .entire_manifold();

   \verm{Mesh} \azul{two_circles} = \verm{Mesh}::Build ( \taag::join )
      .mesh ( circle_1 ) .mesh ( circle_2 .reverse() );

   cylinder .set_as_working_manifold();
   \verm{Mesh} \azul{piece_of_cyl} = \verm{Mesh}::Build ( \taag::frontal ) .desired_length ( seg_size )
      .boundary ( two_circles ) .start_at ( start_1 ) .towards ( \{ \laranja{-1.}, \laranja{0.}, \laranja{0.} \} );

   sphere .set_as_working_manifold();
   \verm{Mesh} \azul{piece_of_sph} = \verm{Mesh}::Build ( \taag::frontal ) .desired_length ( seg_size )
      .boundary ( circle_2 ) .start_at ( start_2 ) .towards ( \{ \laranja{0.}, \laranja{0.}, \laranja{-1.} \} );
                       
   \verm{Mesh} \azul{sphere_and_cylinder} = \verm{Mesh}::Build ( \taag::join )
      .mesh ( piece_of_sph ) .mesh ( piece_of_cyl );
\end{Verbatim}

\begin{figure}[ht] \centering
 \includegraphics[width=105mm]{sphere-cyl}
  \caption{sphere glued to cylinder}
  \label{\numb section 3.\numb fig 6}
\end{figure}

Note how the orientation is important (see paragraphs \ref{\numb section 1.\numb parag 2}
and \ref{\numb section 1.\numb parag 4}).
For meshing the piece of cylinder, we provide its future boundary which is the union of
{\small\tt circle\_\,1} with {\small\tt circle\_\,2.reverse()}.
For meshing the sphere, we provide {\small\tt circle\_\,2}.
In figure \ref{\numb section 3.\numb fig 7}, where a crack has been opened artificially,
we see that the common boundary, {\small\tt circle\_\,2}, has a certain orientation when seen
from the cylinder and has the opposite orientation when seen from the sphere.
If we do not respect these orientations, {\maniFEM} will be unable to {\small\tt join} the two
meshes.

\begin{figure}[ht] \centering
 \includegraphics[width=110mm]{crack}
  \caption{zoom around the joint}
  \label{\numb section 3.\numb fig 7}
\end{figure}

Note that {\small\tt interface} is a disconnected manifold, made of two closed loops,
one of them being {\small\tt circle\_\,2} (the other one shows up in
paragraph \ref{\numb section 3.\numb parag 19} under the name {\small\tt circle\_\,3}).
However, \maniFEM{} has no global knowledge about the manifold.
Even after invoking method {\small\tt entire\_\,manifold()}, the frontal mesh generation
algorithm will only mesh one of the circles.

We must provide detailed information to the {\small\tt\verm{Mesh}::Build}\,er in order to
obtain the correct loop with the correct orientation.
A statement like

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,
   baselinestretch=0.94,framesep=2mm                     ]
   \verm{Mesh} \azul{circle_2} = \verm{Mesh}::Build ( \taag::frontal ) .entire_manifold()
                                                .desired_length ( seg_size );
\end{Verbatim}

\noindent would produce a run-time error asking the user to specify the orientation
(see comments in paragraph \ref{\numb section 3.\numb parag 10} about curves in $ \mathbb{R}^3 $).
If we didn't care about the orientation (but we do care in this example), we could use
a statement like

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,
   baselinestretch=0.94,framesep=2mm                     ]
   \verm{Mesh} \azul{circle_2} = \verm{Mesh}::Build ( \taag::frontal ) .entire_manifold()
      .orientation ( \taag::random ) .desired_length ( seg_size );
\end{Verbatim}

\noindent and {\maniFEM} would mesh one connected component of the manifold {\small\tt intersection}
(we would have no control on which component {\maniFEM} happens to find).

If we want to close the extremity of the cylinder, it suffices to add a few lines of code\,:

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,
   baselinestretch=0.94,framesep=2mm                     ]
   RR3 .implicit ( x == \laranja{1.5} );
   \verm{Mesh} \azul{disk} = \verm{Mesh}::Build ( \taag::frontal ) .boundary ( circle_1 .reverse() )
      .start_at ( start_1 ) .towards ( \{ \laranja{0.}, \laranja{0.}, \laranja{-1.} \} ) .desired_length ( seg_size );
   \verm{Mesh} \azul{sphere_and_cylinder} = \verm{Mesh}::Build ( \taag::join )
      .mesh ( piece_of_sph ) .mesh ( piece_of_cyl ) .mesh ( disk );
\end{Verbatim}

We have chosen the diameter of the cylinder slightly smaller than $1$.
Had we chosen a diameter equal to $1$, the cylinder would be tangent to the sphere at point
$ (0,0,1) $.
At that point, the two equations defining the {\small\tt\azul{intersection}} manifold would be
degenerate (the Jacobian matrix would not have full rank).
This is a situation which {\maniFEM} cannot handle yet; it is discussed in paragraph
\ref{\numb section 3.\numb parag 22}.


          %------------------%
\section{~~Sharp edges, again}\label{\numb section 3.\numb parag 19}
          %------------------%

With a few changes to the code in paragraph \ref{\numb section 3.\numb parag 18},
we can cut two holes in the sphere and create a tunnel using the cylinder's wall.
\medskip

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 3.\numb parag 19}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                              ]
   \verm{Manifold} \azul{cylinder} = RR3 .implicit ( y*y + (z-\laranja{0.5})*(z-\laranja{0.5}) == rc*rc );
   \verm{Manifold} \azul{sphere} = RR3 .implicit ( x*x + y*y + z*z == rs*rs );
   \verm{Manifold} \azul{interface} ( \taag::intersect, cylinder, sphere );

   \cinza{// we choose names start_2 and circle_2 for consistency with previous paragraph}
   \verm{Cell} \azul{start_2} ( \taag::vertex, \taag::of_coords, \{ \laranja{1.}, \laranja{0.}, \laranja{0.5} - rc \}, \taag::project );
   \verm{Mesh} \azul{circle_2} = \verm{Mesh}::Build ( \taag::frontal ) .desired_length ( seg_size )
      .start_at ( start_2 ) .towards ( \{ \laranja{0.}, \laranja{1.}, \laranja{0.} \} ) .entire_manifold();
   \verm{Cell} \azul{start_3} ( \taag::vertex, \taag::of_coords, \{ \laranja{-1.}, \laranja{0.}, \laranja{0.5} - rc \}, \taag::project );
   \verm{Mesh} \azul{circle_3} = \verm{Mesh}::Build ( \taag::frontal ) .desired_length ( seg_size )
      .start_at ( start_3 ) .towards ( \{ \laranja{0.}, \laranja{1.}, \laranja{0.} \} ) .entire_manifold();
   \verm{Mesh} \azul{two_circles} = \verm{Mesh}::Build ( \taag::join )
      .mesh ( circle_2 .reverse() ) .mesh ( circle_3 );

   cylinder .set_as_working_manifold();
   \verm{Mesh} \azul{piece_of_cyl} = \verm{Mesh}::Build ( \taag::frontal ) .desired_length ( seg_size )
      .boundary ( two_circles ) .start_at ( start_2 ) .towards ( \{ \laranja{-1.}, \laranja{0.}, \laranja{0.} \} );
\end{Verbatim}

\begin{figure}[ht] \centering
\if\production 1
 \includegraphics[width=85mm]{sphere-tunnel-cloud-im}
\else
 \includegraphics[width=88mm]{sphere-tunnel-low-res}
\fi
  \caption{sphere with tunnel}
  \label{\numb section 3.\numb fig 8}
\end{figure}

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 3.\numb parag 19}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                              ]
   sphere .set_as_working_manifold();
   \verm{Mesh} \azul{piece_of_sph} = \verm{Mesh}::Build ( \taag::frontal ) .desired_length ( seg_size )
      .boundary ( two_circles .reverse() )
      .start:at ( start_2 ) .towards ( \{ \laranja{0.}, \laranja{0.}, \laranja{-1.} \} );
   \verm{Mesh} \azul{perf_sphere} = \verm{Mesh}::Build ( \taag::join )
      .mesh ( piece_os_sph ) .mesh ( piece_of_cyl );
\end{Verbatim}

The manifold {\small\tt interface} is disconnected.
Each declaration of {\small\tt\verm{Mesh} \azul{circle\_\,2}} and
{\small\tt\verm{Mesh} \azul{circle\_\,3}} meshes only a connected component of {\small\tt interface},
depending on the starting point we provide.

Had we chosen a cylinder of diameter $1$, a singular point would appear;
the two ``circles'' would touch at point $ (0,0,1) $.
This is a situation which {\maniFEM} cannot handle yet; it is discussed in paragraph
\ref{\numb section 3.\numb parag 22}.


          %------------------%
\section{~~Overlapping meshes}\label{\numb section 3.\numb parag 20}
          %------------------%

In \maniFEM, cells (including vertices) are independent of their geometric coordinates.
We can build two distinct vertices {\small\tt\azul{O1}} and {\small\tt\azul{O2}}, both occupying
the origin of {\small\tt RR2}.
Similarly, {\small\tt\azul{A1}} and {\small\tt\azul{A2}} have the same geometric coordinates,
although they are different {\small\tt\verm{Cell}} objects (with different cores).
Also, segments {\small\tt\azul{O1A1}} and {\small\tt\azul{O2A2}} are superimposed.

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 3.\numb parag 20}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                              ]
   \verm{Cell} \azul{O1} ( \taag::vertex );  x(O1) = \laranja{0.};  y(O1) = \laranja{0.};
   \verm{Cell} \azul{A1} ( \taag::vertex );  x(A1) = \laranja{1.};  y(A1) = \laranja{0.};
   \verm{Mesh} \azul{O1A1} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( O1 ) .stop_at ( A1 ) .divided_in ( n );
   \verm{Cell} \azul{O2} ( \taag::vertex );  x(O2) = \laranja{0.};  y(O2) = \laranja{0.};
   \verm{Cell} \azul{A2} ( \taag::vertex );  x(A2) = \laranja{1.};  y(A2) = \laranja{0.};
   \verm{Mesh} \azul{O2A2} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( O2 ) .stop_at ( A2 ) .divided_in ( n );
\end{Verbatim}

We can take advantage of this peculiarity of {\maniFEM} and build meshes which pass more than once
in the same region of the space (they overlap themselves).
In this paragraph, we build a mesh by {\small\tt join}ing four half-annuli.

\begin{figure}[ht] \centering
  \psfrag{O}{\small\tt\textcolor{textindraw}{O}}
  \psfrag{A}{\small\tt\textcolor{textindraw}{A}}
  \psfrag{B}{\small\tt\textcolor{textindraw}{B}}
  \psfrag{C}{\small\tt\textcolor{textindraw}{C}}
  \psfrag{D}{\small\tt\textcolor{textindraw}{D}}
  \psfrag{E}{\small\tt\textcolor{textindraw}{E}}
 \includegraphics[width=115mm]{infinity-overlap}
  \caption{a self-overlapping mesh}
  \label{\numb section 3.\numb fig 9}
\end{figure}

The result, shown in figure \ref{\numb section 3.\numb fig 9},
is not two overlapping annuli, it is an infinity-shaped strip.
The boundary of this mesh has two connected components.
Each of these components is a (self-intersecting) smooth curve.
Due to the overlapping, it is impossible to distinguish between an ``inner'' boundary
and an ``outer'' boundary.
In contrast, the mesh built in paragraph \ref{\numb section 3.\numb parag 17}
has a boundary made of three connected components\,: two inner circles
and an outer boundary with two re-entrant corners.


                    %------------%
\section{~~\cinzasec{Singularities}}\label{\numb section 3.\numb parag 21}
                    %------------%

{\normalfont\bfseries The code described in this paragraph does not work yet.
It should be regarded as a mere declaration of intentions.}
\medskip

If we want to mesh (a part of) a surface with singular points, we must give to {\maniFEM}
knowledge about these singularities.
A typical example is the vertex of a cone.

\begin{figure}[ht] \centering
 \includegraphics[width=90mm]{cone}
  \caption{a singularity (vertex)}
  \label{\numb section 3.\numb fig 10}
\end{figure}

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=code not working,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                  ]
   \verm{Manifold} \azul{cone_manif} = RR3 .implicit ( x*x + y*x == z*z );

   cone_manif .implicit ( z == \laranja{1.} );
   \verm{Cell} \azul{A} ( \taag::vertex );  x(A) = \laranja{1.};  y(A) = \laranja{0.};  z(A) = \laranja{1.};
   \verm{Mesh} \azul{circle} = \verm{Mesh}::Build ( \taag::frontal ) .desired_length ( \laranja{0.1} )
      .start_at ( A ) .towards ( \{ \laranja{0.}, \laranja{-1.}, \laranja{0.} \} );

   cone_manif .set_as_working_manifold();
   \verm{Cell} \azul{V} ( \taag::vertex );  x(V) = \laranja{0.};  y(V) = \laranja{0.};  z(V) = \laranja{0.};
   \verm{Mesh} \azul{cone} = \verm{Mesh}::Build ( \taag::frontal ) .desired_length ( \laranja{0.1} )
      .boundary ( circle ) .start_at ( A ) .towards ( \{ \laranja{-1.}, \laranja{0.}, \laranja{-1.} \} )
      .singular ( V );
\end{Verbatim}


                    %--------------------%
\section{~~\cinzasec{Singularities, again}}\label{\numb section 3.\numb parag 22}
                    %--------------------%

{\normalfont\bfseries The code described in this paragraph does not work yet.
It should be regarded as a mere declaration of intentions.}
\medskip

Besides vertices like the one described in paragraph \ref{\numb section 3.\numb parag 21},
another kind of singularity appears when we intersect two manifolds which have a tangency point.
This happens if we choose {\small\tt\azul{rc} = \laranja{0.5}} in paragraph
\ref{\numb section 3.\numb parag 18} or \ref{\numb section 3.\numb parag 19}.

We focus on the piece of cylinder from paragraph \ref{\numb section 3.\numb parag 19}
(which is to be subsequently {\small\tt join}ed with a sphere with two holes).
\vfil\eject

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=code not working,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                  ]
   \verm{Manifold} \azul{cylinder} = RR3 .implicit ( y*y + (z-\laranja{0.5})*(z-\laranja{0.5}) == \laranja{0.25} );
   \verm{Manifold} \azul{infinity} = cylinder .implicit ( x*x + y*y + z*z == \laranja{1.} );

   \verm{Cell} \azul{V} ( \taag::vertex );  x(V) = \laranja{0.};  y(V) = \laranja{0.};  z(V) = \laranja{1.};
   \verm{Mesh} \azul{circle_1} = \verm{Mesh}::Build ( \taag::frontal )
      .start_at ( V ) .towards ( \{ \laranja{1.}, \laranja{1.}, \laranja{0.} \} )
      .singular ( V ) .desired_length ( \laranja{0.1} );
   \verm{Mesh} \azul{circle_2} = \verm{Mesh}::Build ( \taag::frontal )
      .start_at ( V ) .towards ( \{ \laranja{-1.}, \laranja{-1.}, \laranja{0.} \} )
      .singular ( V ) .desired_length ( \laranja{0.1} );

   cylinder .set_as_working_manifold();
   \verm{Cell} \azul{W} = circle_1 .cell_in_front_of (V) .tip();
   \verm{Mesh} \azul{piece_of_cyl} = \verm{Mesh}::Build ( \taag::frontal )
      .boundary ( circle_1, circle_2 )
      .start_at ( W ) .towards ( \{ \laranja{-1.}, \laranja{1.}, \laranja{0.} \} )
      .singular ( V ) .desired_length ( \laranja{0.1} );
\end{Verbatim}

\begin{figure}[ht] \centering
 \includegraphics[width=95mm]{cyl}
  \caption{a singularity (napkin)}
  \label{\numb section 3.\numb fig 11}
\end{figure}

{\ManiFEM} accepts as {\small\tt\verm{Manifold}} a self-intersecting set like {\small\tt infinity}.
In {\maniFEM}, an implicit manifold is simply a level set of one or two symbolic expressions
involving the coordinates of the surrounding, Euclidean manifold.
However, in the neighbourhood of a singularity, the equation(s) are degenerate and certain
parts of {\maniFEM} do not work as expected.
In particular, the projection algorithm onto the manifold may fail to converge.
By specifying (in the {\small\tt\verm{Mesh}::Build}\,er) {\small\tt V} as singular point,
we tell {\maniFEM} that it must take special care in that neighbourhood.

Unlike in paragraph \ref{\numb section 3.\numb parag 19}, here we cannot {\small\tt join} the
two meshes {\small\tt circle\_\,1} and {\small\tt circle\_\,2}.
{\ManiFEM} is unable to join two closed polygonal lines having a vertex in common;
in other words, it does not handle self-intersecting {\small\tt\verm{Mesh}}\hglue0.5pt es.\,%
\footnote{{} Actually, STSI meshes, described in paragraph \ref{\numb section 13.\numb parag 16},
can intersect themselves. But we do not want the final user to deal with STSI meshes.}
This is why we provide the two pieces of boundary separately.
\vfil\eject


          %-------------------%
\section{~~Non-uniform meshing}\label{\numb section 3.\numb parag 23}
          %-------------------%

The desired length may be a non-constant function.

\vskip 15pt
\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 3.\numb parag 23}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                              ]
   \verm{Function} \azul{d} = \laranja{0.03} + \laranja{0.04} * ( (x+\laranja{0.3})*(x+\laranja{0.3}) + (y-\laranja{0.9})*(y-\laranja{0.9}) );

   \verm{Manifold} \azul{circle} = RR2 .implicit ( x*x + y*y == \laranja{1.} );
   \verm{Mesh} \azul{outer} = \verm{Mesh}::Build ( \taag::frontal ) .entire_manifold() .desired_length (d);

   \verm{Manifold} \azul{ellipse} = RR2 .implicit ( x*x + (y-\laranja{0.37})*(y-\laranja{0.37}) + \laranja{0.3}*x*y == \laranja{0.25} );
   \verm{Mesh} \azul{inner} = \verm{Mesh}::Build ( \taag::frontal ) .entire_manifold() .desired_length (d);

   \verm{Mesh} \azul{bdry} = \verm{Mesh}::Build ( \taag::join ) .mesh ( outer ) .mesh ( inner .reverse() );

   RR2 .set_as_working_manifold();
   \verm{Mesh} \azul{disk} = \verm{Mesh}::Build ( \taag::frontal ) .boundary ( bdry ) .desired_length (d);
\end{Verbatim}
\vskip -2mm

It is the user's responsibility to provide a length {\small\tt d} which takes positive values
at all points of the future mesh.
Also, {\small\tt d} should be a reasonably smooth function; sharp variations should be avoided.

\begin{figure}[ht] \centering
 \includegraphics[width=100mm]{disk-non-unif}
  \caption{non-uniform mesh}
  \label{\numb section 3.\numb fig 12}
\end{figure}

Compare with the mesh in paragraph \ref{\numb section 3.\numb parag 3}.
\vfil\eject


          %---------------------%
\section{~~Two intersecting tori}\label{\numb section 3.\numb parag 24}
          %---------------------%

Going back to the two tori in paragraph \ref{\numb section 3.\numb parag 7},
we now build the edges first and obtain a sharp, precise cut
(forget about {\small\tt\verm{smooth\_\,min}}).

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 3.\numb parag 24}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                              ]
   \cinza{// unlike in paragraph 3.7, here we don't need to cut f1 and f3 with 0.1}
   \cinza{// (the shape of each torus avoids the singularities)}
   \cinza{// we change slightly f3 (replace 0.4 by 0.5) to highlight the intersection}
   \verm{Function} \azul{f1} = x*x + y*y;
   \verm{Function} \azul{f2} = \laranja{1.} - \verm{power} ( f1, \laranja{-0.5} );
   \verm{Function} \azul{d1} = f1 * f2 * f2 + z*z;  \cinza{// squared distance to a circle in the xy plane}
   \verm{Function} \azul{f3} = (x-\laranja{0.5})*(x-\laranja{0.5}) + z*z;
   \verm{Function} \azul{f4} = \laranja{1.} - \verm{power} ( f3, \laranja{-0.5} );
   \verm{Function} \azul{d2} = y*y + f3 * f4 * f4;  \cinza{// squared distance to a circle in the xz plane}
\end{Verbatim}
\vskip -2mm

We also define the desired length of segments as a {\small\tt\verm{Function}} in order to
get a finer mesh around the joints\,:

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 3.\numb parag 24}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                              ]
   \verm{Function} \azul{seg_size} = \laranja{0.1} * \verm{power} ( \laranja{0.15} + \verm{abs} ( d2 - d1 ), \laranja{0.4} );
\end{Verbatim}

\begin{figure}[ht] \centering
 \includegraphics[width=90mm]{two-tori-sharp}
  \caption{sharp edges}
  \label{\numb section 3.\numb fig 13}
\end{figure}

We begin by meshing each connected component of the intersection between the two tori,
then {\small\tt join} them in a disconnected one-dimensional mesh\,:

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 3.\numb parag 24}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                              ]
   \verm{Manifold} \azul{intersection} = RR3 .implicit ( d1 == \laranja{0.15}, d2 == \laranja{0.15} );
   \verm{Cell} \azul{start_1} ( \taag::vertex, \taag::of_coords, \{ \laranja{1.3}, \laranja{-0.4}, \laranja{0.} \}, \taag::project );
   \verm{Mesh} \azul{loop_1} = \verm{Mesh}::Build ( \taag::frontal ) .desired_length ( seg_size )
      .entire_manifold() .start_at ( start_1 ) .towards ( \{ \laranja{0.}, \laranja{0.}, \laranja{1.} \} );
   \verm{Cell} \azul{start_2} ( \taag::vertex, \taag::of_coords, \{ \laranja{-0.9}, \laranja{0.}, \laranja{0.4} \}, \taag::project );
   \verm{Mesh} \azul{loop_2} = \verm{Mesh}::Build ( \taag::frontal ) .desired_length ( seg_size )
      .entire_manifold() .start_at ( start_2 ) .towards ( \{ \laranja{0.}, \laranja{1.}, \laranja{0.} \} );
   \verm{Mesh} \azul{two_loops} = \verm{Mesh}::Build ( \taag::join ) .mesh ( loop_1 ) .mesh ( loop_2 );
\end{Verbatim}

Starting from this disconnected mesh, we build two tori, then {\small\tt join} them together.
We start the frontal mesh generation process at the same location, {\small\tt start\_\,1},
but provide different directions.
Each of these directions is approximately tangent to the current manifold
and approximately orthogonal to the boundary, at point {\small\tt start\_\,1}.

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 3.\numb parag 24}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                              ]
   RR3 .implicit ( d1 == \laranja{0.15} );
   \verm{Mesh} \azul{torus_1} = \verm{Mesh}::Build ( \taag::frontal ) .boundary ( two_loops )
      .start_at ( start_1 ) .towards ( \{ \laranja{-0.2}, \laranja{-1.}, \laranja{0.} \} )
      .desired_length ( seg_size );
   RR3 .implicit ( d2 == \laranja{0.15} );
   \verm{Mesh} \azul{torus_2} = \verm{Mesh}::Build ( \taag::frontal ) .boundary ( two_loops .reverse() )
      .start_at ( start_1 ) .towards ( \{ \laranja{1.}, \laranja{-0.2}, \laranja{0.} \} )
      .desired_length ( seg_size );
   \verm{Mesh} \azul{two_tori} = \verm{Mesh}::Build ( \taag::join ) .mesh ( torus_1 ) .mesh ( torus_2 );
\end{Verbatim}

Figure \ref{\numb section 3.\numb fig 13} shows the resulting mesh.


          %----------------------------%
\section{~~Filling tori with tetrahedra}\label{\numb section 3.\numb parag 25}
          %----------------------------%

We fill the volume bounded by the surface {\small\tt two\_tori} (built in the previous paragraph)
with tetrahedra.
Like in paragraph \ref{\numb section 3.\numb parag 8}, it suffices to switch to the manifold
{\small\tt RR3} and invoke the frontal mesh generation algorithm :

\vskip 20pt
\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 3.\numb parag 25}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                              ]
   RR3 .set_as_working_manifold();
   \verm{Mesh} \azul{two_tori_filled} = \verm{Mesh}::Build ( \taag::frontal )
      .boundary ( two_tori ) .desired_length ( seg_size );
\end{Verbatim}

\begin{figure}[ht] \centering
\if\production 1
  \includegraphics[width=105mm]{two-tori-filled}
  % https://cloudconvert.com/
\else
  \includegraphics[width=105mm]{two-tori-filled-low-res}
  % https://convertio.co/png-eps/
\fi
  \caption{filling two tori with tetrahedra}
  \label{\numb section 3.\numb fig 14}
\end{figure}

We have chosen a different {\small\tt seg\_size} from paragraph \ref{\numb section 3.\numb parag 24}
because that function has singularities.
Those singularities are avoided in paragraph \ref{\numb section 3.\numb parag 24} because the frontal
mesh generation happens on the surface {\small\tt two\_tori}.
In the present paragraph, the mesh generation happens inside the volume.

In figure \ref{\numb section 3.\numb fig 14}, a cut allows the user to see inner cells.
This was done using the following options of {\small\tt gmsh}: {\small\tt Tools} $\to$
{\small\tt Clipping} $\to$ {\small\tt Mesh} $\to$ {\small\tt Planes} $\to$
{\small\tt Keep} {\small\tt  whole} {\small\tt  elements}, $ A = -0.25, B = -1., C = 0., D = 0.3 $.

Note that mesh generation with tetrahedra is not fully stable in \maniFEM{} yet,
although it gets the job done in most examples.
Work is ongoing in order to improve the stability and quality of mesh generation with tetrahedra.


          %---------------------------%
\section{~~Changing the Riemann metric}\label{\numb section 3.\numb parag 26}
          %---------------------------%
 
We can attach a non-uniform metric to our manifold; as a consequence, for a constant
{\small\tt desired\_\,length}, the apparent segment length will vary from zone to zone.
For instance, in the code below we set a metric which increases the measured length
of the segments close to the narrow part of the domain.
As a consequence, the meshing algorithm, while trying to build a mesh of constant
{\small\tt desired\_\,length}, will choose shorter segments in the proximity of the narrow zone
(because the length measured by the Riemann metric will be larger than the length
we see in the drawing), thus producing the same result as in paragraph
\ref{\numb section 3.\numb parag 23}.

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 3.\numb parag 26}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                              ]
   \verm{Manifold} \azul{RR2} ( \taag::Euclid, \taag::of_dim, \laranja{2} );
   \verm{Function} \azul{xy} = RR2 .build_coordinate_system ( \taag::Lagrange, \taag::of_degree, \laranja{1} );
   \verm{Function} \azul{x} = xy[\laranja{0}], \azul{y} = xy[\laranja{1}];

   \verm{Function} \azul{d} = \laranja{0.3} + \laranja{0.4} * ( (x+\laranja{0.3})*(x+\laranja{0.3}) + (y-\laranja{0.9})*(y-\laranja{0.9}) );
   RR2 .set_metric ( \taag::isotropic, \laranja{1.} / d );
   \cinza{// implicit manifolds 'circle' and 'ellipse' will inherit this metric}

   \verm{Manifold} \azul{circle} = RR2 .implicit ( x*x + y*y == \laranja{1.} );
   \verm{Mesh} \azul{outer} = \verm{Mesh}::Build ( \taag::frontal )
      .entire_manifold() .desired_length ( \laranja{0.1} );

   \verm{Manifold} \azul{ellipse} = RR2 .implicit ( x*x + (y-\laranja{0.37})*(y-\laranja{0.37}) + \laranja{0.3}*x*y == \laranja{0.25} );
   \verm{Mesh} \azul{inner} = \verm{Mesh}::Build ( \taag::frontal )
      .entire_manifold() .desired_length ( \laranja{0.1} );

   \verm{Mesh} \azul{bdry} = \verm{Mesh}::Build ( \taag::join ) .mesh ( outer ) .mesh ( inner .reverse() );

   RR2 .set_as_working_manifold();
   \verm{Mesh} \azul{disk} = \verm{Mesh}::Build ( \taag::frontal )
      .boundary ( bdry ) .desired_length ( \laranja{0.1} );
\end{Verbatim}

These two approaches (the one described in paragraph \ref{\numb section 3.\numb parag 23} and
the one described here) can be used interchangeably.
It is possible to use both in the same code, but the code will become rather obscure.


          %------------------%
\section{~~Anisotropic metric}\label{\numb section 3.\numb parag 27}
          %------------------%

The technique described in paragraph \ref{\numb section 3.\numb parag 26} can be generalized to
an anisotropic Riemann metric.
We define the metric by means of a square matrix $M$ which must be symmetric positive definite.
The arguments of {\small\tt set\_\,metric} are, besides a descriptive {\small\tt\taag},
$ m_{11} $, $ m_{12} $ and $ m_{22} $ for two dimensions,
$ m_{11} $, $ m_{12} $, $ m_{13} $, $ m_{22} $, $ m_{23} $ and $ m_{33} $ for three dimensions.

The matrix $M$ should be interpreted in the following sense\,: for any two vectors $v$ and $w$
tangent to the manifold at a given point $P$, their inner product is defined as
$ \langle v, w \rangle_a = \sum_{i,j} m_{ij} (\mbox{\small\tt P})\, v_j w_i $.
As a consequence, the norm of a vector $v$ is given by $ \|v\|_a = \sqrt{ \sum_{i,j} m_{ij}
(\mbox{\small\tt P})\, v_j v_i } $ (the subscript ${}_a$ stands for ``anisotropic'').

In the code below, we define $M$ as the sum between the identity matrix and a perturbation
depending on a quantity {\small\tt beta} which is very small at points far from the narrow part
of the domain.
We have chosen this rather complicated expression for {\small\tt beta} in order for the matrix $M$
to be the square of another matrix, showing up in paragraph \ref{\numb section 3.\numb parag 28}.

\vskip 15pt
\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 3.\numb parag 27}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                              ]
   \verm{Function} \azul{alpha} = \laranja{5.} + \laranja{10.} * ( (x+\laranja{0.3})*(x+\laranja{0.3}) + (y-\laranja{0.9})*(y-\laranja{0.9}) );
   \verm{Function} \azul{beta} = ( \laranja{1.} + \laranja{5.} / alpha ) / alpha;
   RR2 .set_metric ( \taag::m11_m12_m22, \laranja{1.} + \laranja{2.}*beta, \laranja{-6.}*beta, \laranja{1.} + \laranja{18.}*beta );
   \cinza{// implicit manifolds 'circle' and 'ellipse' will inherit this metric}
\end{Verbatim}

\begin{figure}[ht] \centering
 \includegraphics[width=90mm]{disk-anisotrop}
  \caption{anisotropic mesh}
  \label{\numb section 3.\numb fig 15}
\end{figure}

Compare with the mesh in paragraph \ref{\numb section 3.\numb parag 3}.

This result cannot be achieved using the approach of paragraph
\ref{\numb section 3.\numb parag 23} (by providing a non-constant desired length).


          %---------------------------------------------%
\section{~~Anisotropic metric, square root of the matrix}\label{\numb section 3.\numb parag 28}
          %---------------------------------------------%

Instead of describing the metric as in paragraph \ref{\numb section 3.\numb parag 27},
we can provide another symmetric positive definite matrix $A$ and define the inner product as
$ \langle v, w \rangle_a = \langle Av, Aw \rangle $, where $ \langle \cdot, \cdot\rangle $
stands for the usual Euclidian product.
Thus, the norm of a vector is given by $ \|v\|_a = \|Av\| $, where $ \|\cdot\| $ stands for
the usual Euclidian norm.

The matrices $M$ from paragraph \ref{\numb section 3.\numb parag 27} and $A$ here are related
by $ M = A^2 $, so $A$ may be viewed as the ``square root'' of $M$.

For providing this information to {\maniFEM} we use a {\small\tt\taag::square\_\,root}.
You may also replace {\small\tt\taag::m11\_\,m12\_\,m22} by
{\small\tt\taag::a11\_\,a12\_\,a22}, they are interchangeable.

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 3.\numb parag 28}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                              ]
   \verm{Function} \azul{alpha} = \laranja{5.} + \laranja{10.} * ( (x+\laranja{0.3})*(x+\laranja{0.3}) + (y-\laranja{0.9})*(y-\laranja{0.9}) );
   RR2 .set_metric ( \taag::square_root,
                     \taag::a11_a12_a22, \laranja{1.} + \laranja{1.}/alpha, \laranja{-3.}/alpha, \laranja{1.} + \laranja{9.}/alpha );
\end{Verbatim}

The code above will produce the same mesh as in paragraph \ref{\numb section 3.\numb parag 27}.
Providing the square root of $M$ rather than $M$ itself turns the frontal mesh generation process
more efficient ({\maniFEM} can avoid computing many square roots, thus gaining speed).

However, if the matrix $A$ is given by expressions (e.g.\ involving square roots)
which are more complicated than those defining $M$, there is no advantage
in using the approach presented here (with {\small\tt\taag::square\_\,root}).
In these cases, we recommend using the direct approach
described in paragraph \ref{\numb section 3.\numb parag 27}.


          %---------------------%
\section{~~Inner spectral radius}\label{\numb section 3.\numb parag 29}
          %---------------------%

During frontal mesh generation with anisotropic Riemann metric,
following either of the paths outlined in paragraph \ref{\numb section 3.\numb parag 27} or
\ref{\numb section 3.\numb parag 28}, {\maniFEM} must compute, when building each new vertex,
the inner spectral radius of the matrix $A$, or, equivalently, compute the square root of
the inner spectral radius of $M$.
The reasons are explained in paragraph \ref{\numb section 13.\numb parag 15}.

By ``inner spectral radius'' we simply mean the lowest eigenvalue of the matrix (which should
be positive).

In order to make the frontal mesh generation process more efficient, the user may provide
(a lower bound on) the inner spectral radius of the matrix $M$ as below.

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 3.\numb parag 29}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                              ]
   \verm{Function} \azul{alpha} = \laranja{5.} + \laranja{10.} * ( (x+\laranja{0.3})*(x+\laranja{0.3}) + (y-\laranja{0.9})*(y-\laranja{0.9}) );
   \verm{Function} \azul{beta} = ( \laranja{1.} + \laranja{5.} / alpha ) / alpha;
   RR2 .set_metric ( \taag::inner_spectral_radius, \laranja{1.},
                     \taag::d11_d12_d22, \laranja{2.}*beta, \laranja{-6.}*beta, \laranja{18.}*beta );
\end{Verbatim}

So, we provide $M$ as the sum between a ``principal part'' $ \sigma I $ and a ``deviatoric part'' $D$.
The scalar $ \sigma $ should be either a positive constant or a {\small\tt\verm{Function}} taking
positive values (in the above, $ \sigma $ is $1$) .
The deviatoric matrix $D$ should be symmetric positive semi-definite.
For maximum efficiency, $D$ should be singular but this is not mandatory.
You may replace {\small\tt\taag::m11\_\,m12\_\,m22} by
{\small\tt\taag::d11\_\,d12\_\,d22}, they are interchangeable.


          %----------------------------------%
\section{~~Inner spectral radius, square root}\label{\numb section 3.\numb parag 30}
          %----------------------------------%

We can combine both advantages of paragraphs \ref{\numb section 3.\numb parag 28} and
\ref{\numb section 3.\numb parag 29} by providing the matrix $ A = \sqrt M $ as the sum
between a ``principal part'' $ \sigma I $ and a ``deviatoric part''\,:

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 3.\numb parag 30}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                              ]
   \verm{Function} \azul{alpha} = \laranja{5.} + \laranja{10.} * ( (x+\laranja{0.3})*(x+\laranja{0.3}) + (y-\laranja{0.9})*(y-\laranja{0.9}) );
   RR2 .set_metric ( \taag::square_root, \taag::inner_spectral_radius, \laranja{1.},
                     \taag::m11_m12_m22, \laranja{1.}/alpha, \laranja{-3.}/alpha, \laranja{9.}/alpha  );
\end{Verbatim}

Paragraphs \ref{\numb section 3.\numb parag 27}\,--\,\ref{\numb section 3.\numb parag 30} build
the same mesh shown in figure \ref{\numb section 3.\numb fig 15}, with increasing degree of efficiency.


          %-----------%
\section{~~Future work}\label{\numb section 3.\numb parag 31}
          %-----------%

It would be nice to define domains using inequalities between {\small\tt\verm{Function}}\hglue0.5pt s.

The stability of frontal mesh generation with tetrahedra should be improved, as well as the quality
of the produced mesh.
